#include <fstream>
#include <cstdlib>
#include <cstdio>

#include <errno.h>
#include <fcntl.h>
#include <unistd.h>

#include <arc/common.h>

std::string GetEnv(const std::string& var) {

	char* env = getenv(var.c_str());
	if(env == NULL)
		return "";
	return env;
}


std::string GlobusErrorString(globus_object_t* error) {

	char* tmp = globus_object_printable_to_string(error);
	std::string errstr("");
	if (tmp!=NULL) errstr = tmp;

	free(tmp);
	return errstr;
}


std::list<std::string> ReadFile(const std::string& filename) {

	std::list<std::string> lines;
	std::string line;

	std::ifstream readin(filename.c_str());
	while(getline(readin, line))
		lines.push_back(line);

	readin.close();
	return lines;
}


void LockFile(const std::string& filename) {

	std::string jobfilelock = filename + ".lock";
	int fd = open(jobfilelock.c_str(), O_WRONLY|O_CREAT|O_EXCL);
	while ((fd < 0) && (errno == EEXIST)) {
		usleep (10000);
		fd = open(jobfilelock.c_str(), O_WRONLY|O_CREAT|O_EXCL);
	}
}


void UnlockFile(const std::string& filename) {

	std::string jobfilelock = filename + ".lock";
	remove(jobfilelock.c_str());
}
