#include <iostream>
#include <list>

#include <arc/mdsquery.h>
#include <arc/notify.h>

int main() {

	SetNotifyLevel(DEBUG);

	URL url("ldap://farm.hep.lu.se:2135/o=grid/mds-vo-name=local");

	std::list<Job> jobs;
	try {
		jobs = GetAllJobs(url);
	} catch(ARCLibError e) {
		std::cout << e.what() << std::endl;
	}

	std::cout << "Jobs found: " << jobs.size() << std::endl;
	if (jobs.size()>0) {

		std::cout << "Getting jobinfo for job: " << jobs.begin()->id << std::endl;
		Job myjob;
		try {
			myjob = GetJobInfo(jobs.begin()->id);
		} catch(ARCLibError e) {
			std::cout << e.what() << std::endl;
		}

		std::cout << "Job-owner: " << myjob.owner << std::endl;

	}
}
