#include "../../std.h"

#include "../../misc/inttostring.h"
#include "../../misc/url_options.h"

#include "srm_url.h"

std::string SRM_URL::ContactURL(void) const {
  if(!valid) return empty;
  return ("httpg://"+host+":"+inttostring(port)+"/"+path);
  //return ("https://"+host+":"+inttostring(port)+"/"+path);
}

std::string SRM_URL::BaseURL(void) const {
  if(!valid) return empty;
  return (proto+"://"+host+":"+inttostring(port)+"/"+path+"?SFN=");
}

std::string SRM_URL::ShortURL(void) const {
  return (proto+"://"+host+":"+inttostring(port));
}

SRM_URL::SRM_URL(const char* url):URL(url) {
  if(!valid) return;
  if(proto != "srm") { valid=false; return; };
  if(port == 0) port=8443;
  int p = path.find("?SFN=");
  if(p != std::string::npos) {
    filename=path.c_str()+p+5;
    path.resize(p);
    return;
  };
  // Only supported version from client's side is 1.1
  filename=path;
  //path="srm/srm.1.1.endpoint";
  path="srm/managerv1";
}

