#include "../std.h"
//#include <dlfcn.h>
//#include "../jobs/users.h"
//#include "../jobs/states.h"
//#include <sys/resource.h>
//#include <sys/wait.h>
//#include <pthread.h>
//#include "../config/environment.h"
//#include "../config/conf.h"
//#include "../misc/substitute.h"
//#include "../misc/log_time.h"

#include "run.h"
#include "run_parallel.h"

#include <iostream>

void* wakeup_func(void* arg) {
  for(;;) {
    sleep(100);
  };
  return NULL;
};

int main(void) {
  Run run;
  Run run2;
  bool res;
  pthread_t wakeup_thread;


  if(pthread_create(&wakeup_thread,NULL,&wakeup_func,NULL) != 0) {
    cerr << "Failed to start new thread" << endl; exit(1);
  };

 
  JobUser user;
  char* args[3] = { "/bin/sleep", NULL, NULL };
  RunElement* re1;
  RunElement* re2;
  RunElement* re3;

  cout<<"Fork 1"<<endl;
  args[1]="2";
  res=RunParallel::run(user,"test",args,&re1,false,false);
  if(!res) { cout<<"Fork 1 failed"<<endl; exit(1); };
  cout<<"Fork 1 succeeded"<<endl;

  cout<<"Fork 2"<<endl;
  args[1]="5";
  res=RunParallel::run(user,"test",args,&re2,false,false,NULL,NULL,NULL);
  if(!res) { cout<<"Fork 2 failed"<<endl; exit(1); };
  cout<<"Fork 2 succeeded"<<endl;

  cout<<"Fork 3"<<endl;
  args[1]="15";
  res=RunParallel::run(user,"test",args,&re3,false,false,NULL,NULL,NULL);
  if(!res) { cout<<"Fork 3 failed"<<endl; exit(1); };
  cout<<"Fork 3 succeeded"<<endl;

  for(int n = 10;n;) n=sleep(n);

  if(re3->get_pid() != -1) { cout<<"Fork 3 not finished yet: "<<re3->get_exit_code()<<endl; }
  else { cout<<"Fork 3 finished: "<<re3->get_exit_code()<<endl; };
  Run::release(re3);

  if(re1->get_pid() != -1) { cout<<"Fork 1 not finished yet: "<<re1->get_exit_code()<<endl; }
  else { cout<<"Fork 1 finished: "<<re1->get_exit_code()<<endl; };
  Run::release(re1);

  if(re2->get_pid() != -1) { cout<<"Fork 2 not finished yet: "<<re2->get_exit_code()<<endl; }
  else { cout<<"Fork 2 finished: "<<re2->get_exit_code()<<endl; };
  Run::release(re2);

  return 0;
}

